property script_author : "Jonathan Nathan"
property script_name : "Countdown"
property script_version : "1.0"
property script_release_date : date "Monday, October 13, 2003 2:35:00 PM"
property script_copyright : ("" & ((year of script_release_date) as Unicode text) & " " & script_author & ". All rights reserved.")

property minute_seconds : 60
property hour_seconds : (minute_seconds * 60)
property day_seconds : (hour_seconds * 24)

property end_date : date "Friday, October 24, 2003 8:00:00 PM" --Jaguar's release date
property countdown : false

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
	if end_date < (current date) then set end_date to ((current date) + day_seconds)
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
end launched

on should quit after last window closed the_object
	return false
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			set hides when deactivated to false
		end tell
		my set_images()
		
	else if object_name = "about" then
		tell the_object
			center
			set contents of text field "title" to (script_name & " v" & script_version)
			set contents of text field "author" to ("by " & script_author)
			set contents of text field "release" to ("Released " & ((month of script_release_date) as Unicode text) & " " & ((day of script_release_date) as Unicode text) & ", " & ((year of script_release_date) as Unicode text))
			set contents of text field "copyright" to (script_copyright)
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		show window "about"
		
	else if object_name = "quit" then
		quit
		
	else if object_name = "set_date" then
		set message_error to ""
		repeat
			set new_date to text returned of (display dialog (message_error & "Enter the end date for the countdown timer:") default answer (end_date as Unicode text) with icon 1)
			try
				set end_date to date new_date
				exit repeat
			on error
				set message_error to "Your input was not a valid date. Please try again." & return & return
			end try
		end repeat
		my write_settings()
		
	end if
end choose menu item

on idle
	--my update_status("idle called")
	my set_images()
	return 1
end idle

on set_images()
	set the_times to my return_countdown()
	set the_image_views to {"days_", "hours_", "minutes_", "seconds_"}
	repeat with i from 1 to (count the_times)
		set {image_1, image_2} to my return_images(item i of the_times)
		set {image_1, image_2} to {load image image_1, load image image_2}
		set image of image view ((item i of the_image_views) & "1") of window "main" to image_1
		set image of image view ((item i of the_image_views) & "2") of window "main" to image_2
		try
			delete image_1
			delete image_2
		end try
	end repeat
end set_images

on return_countdown()
	set seconds_left to end_date - (current date)
	if seconds_left > 0 then
		set countdown to true
	else
		if countdown then display alert "Its " & (end_date as Unicode text) & "!"
		set countdown to false
		return {0, 0, 0, 0}
	end if
	set the_days to seconds_left div day_seconds
	set seconds_left to seconds_left mod day_seconds
	
	set the_hours to seconds_left div hour_seconds
	set seconds_left to seconds_left mod hour_seconds
	
	set the_minutes to seconds_left div minute_seconds
	set the_seconds to seconds_left mod minute_seconds
	
	return {the_days, the_hours, the_minutes, the_seconds}
end return_countdown

on return_images(the_num)
	if the_num < 10 then
		set num_1 to "0"
		set num_2 to the_num as Unicode text
	else
		set num_1 to character 1 of (the_num as Unicode text)
		set num_2 to character 2 of (the_num as Unicode text)
	end if
	return {num_1 & ".gif", num_2 & ".gif"}
end return_images

on register_settings()
	my update_status("registering settings...")
	tell user defaults
		make new default entry at end of default entries with properties {name:"end_date", contents:end_date}
		register
	end tell
	my update_status("settings registered")
end register_settings

on read_settings()
	my update_status("reading settings...")
	tell user defaults
		set end_date to contents of default entry "end_date"
	end tell
	my update_status("settings read")
end read_settings

on write_settings()
	my update_status("writing settings...")
	tell user defaults
		set contents of default entry "end_date" to end_date
	end tell
	my update_status("settings written")
end write_settings

on update_status(the_message)
	log the_message
end update_status